package cn.iocoder.yudao.module.mes.service.subjectmoldplan;

import cn.iocoder.yudao.module.mes.service.subjectmoldplan.SubjectMoldPlanService;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.subjectmoldplan.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.subjectmoldplan.SubjectMoldPlanDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.subjectmoldplan.SubjectMoldPlanMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 项目方案关联 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class SubjectMoldPlanServiceImpl implements SubjectMoldPlanService {

    @Resource
    private SubjectMoldPlanMapper subjectMoldPlanMapper;

    @Override
    public Long createSubjectMoldPlan(SubjectMoldPlanSaveReqVO createReqVO) {
        // 插入
        SubjectMoldPlanDO subjectMoldPlan = BeanUtils.toBean(createReqVO, SubjectMoldPlanDO.class);
        subjectMoldPlanMapper.insert(subjectMoldPlan);
        // 返回
        return subjectMoldPlan.getId();
    }

    @Override
    public void updateSubjectMoldPlan(SubjectMoldPlanSaveReqVO updateReqVO) {
        // 校验存在
        validateSubjectMoldPlanExists(updateReqVO.getId());
        // 更新
        SubjectMoldPlanDO updateObj = BeanUtils.toBean(updateReqVO, SubjectMoldPlanDO.class);
        subjectMoldPlanMapper.updateById(updateObj);
    }

    @Override
    public void deleteSubjectMoldPlan(Long id) {
        // 校验存在
        validateSubjectMoldPlanExists(id);
        // 删除
        subjectMoldPlanMapper.deleteById(id);
    }

    private void validateSubjectMoldPlanExists(Long id) {
        if (subjectMoldPlanMapper.selectById(id) == null) {
            throw exception(SUBJECT_PLAN_NOT_EXISTS);
        }
    }

    @Override
    public SubjectMoldPlanDO getSubjectMoldPlan(Long id) {
        return subjectMoldPlanMapper.selectById(id);
    }

    @Override
    public PageResult<SubjectMoldPlanDO> getSubjectMoldPlanPage(SubjectMoldPlanPageReqVO pageReqVO) {
        return subjectMoldPlanMapper.selectPage(pageReqVO);
    }

}